import cartedabriscola
import giocatori

class Partita:	
	def __init__(self,gioc1,gioc2):
		# banco e' il mazzo di carte da cui pescare
		self.banco=cartedabriscola.Banco()
		self.banco.Mescola()
		self.nmano=1
		self.primo=0
		self.giocatori=(gioc1,gioc2)
		self.briscola=self.banco.EstraiCarta()
		for g in self.giocatori: self.banco.DaiCarte(g,3)
		self.MedioGioco()
		self.Finale()
	def AggiornaVideo(self):
		print 
		print '%%%%% Mano numero ',self.nmano, '%%%%% Briscola = ', self.briscola, "%%%% CarteNelMazzo = ",len(self.banco.carteinmano)
		print self.giocatori[0].nome, " ha " ,self.giocatori[0].punteggio, " punti ",
		print ' --- ',
		print self.giocatori[1].nome, " ha ", self.giocatori[1].punteggio, " punti "
		for g in self.giocatori: print g
	def Turno(self):
		# un 'turno' di gioco
		self.nmano+=1
		# ciascun giocatore sceglie la carta da giocare
		c1 = self.giocatori[self.primo].ScegliCarta(self.briscola)
		c2 = self.giocatori[1-self.primo].ScegliCarta(self.briscola,c1)
		# visualizza scelta
		print self.giocatori[self.primo].nome, " tira ", c1
		print self.giocatori[1-self.primo].nome, " tira ", c2
		# rimuove la scelta dalle carte in mano
		self.giocatori[self.primo].Togli(c1)
		self.giocatori[1-self.primo].Togli(c2)
		# guarda chi ha vinto ed assegna i punti
		if cartedabriscola.Vincente(c1,c2,self.briscola):
			self.primo=1-self.primo
		# se ha vinto chi tira per secondo, aggiorna "primo" per prossimo turno
		self.giocatori[self.primo].punteggio += (c1.Punti() + c2.Punti())
		# aggiorna la lista delle carte vinte dal vincitore
		self.giocatori[self.primo].cartevinte.append(c1)
		self.giocatori[self.primo].cartevinte.append(c2)
		print "vince ",self.giocatori[self.primo].nome
	def MedioGioco(self):
		while not self.banco.Vuoto():
			self.AggiornaVideo()
			self.Turno()
			self.banco.DaiCarte(self.giocatori[self.primo],1)
			self.banco.DaiCarte(self.giocatori[1-self.primo],1)
	def Finale(self):
		print '########## mazzo finito: finale partita ##########'
		self.banco.DaiCarte(self.giocatori[self.primo],1)
		#il perdente dell'ultima mano pesca la briscola
		self.giocatori[1-self.primo].AggiungiCarta(self.briscola)
		while not self.giocatori[0].Vuoto():
			self.AggiornaVideo()
			self.Turno()
		self.AggiornaVideo()
		print
		print self.giocatori[0].nome, " ha preso ",len(self.giocatori[0].cartevinte)," carte"
		print self.giocatori[1].nome, " ha preso ",len(self.giocatori[1].cartevinte)," carte"	
		print "Vincitore : ",
		if self.giocatori[0].punteggio == self.giocatori[1].punteggio:	print "Nessuno (parita')"
		if self.giocatori[0].punteggio > self.giocatori[1].punteggio:	print self.giocatori[0].nome
		if self.giocatori[0].punteggio < self.giocatori[1].punteggio:	print self.giocatori[1].nome
		
		