import cartedabriscola

class Giocatore(cartedabriscola.Banco):
	'giocatore stupido, tira la prima carta che ha in mano'
	def __init__(self,nome=""):
		self.nome=nome
		self.punteggio=0
		self.carteinmano=[]
		self.cartevinte=[]
	def AggiungiCarta(self,carta):
	    self.carteinmano.append(carta)
	def __str__(self):
		s="Mano di " + self.nome
		if self.Vuoto(): return s+" Vuota!"
		for i in self.carteinmano:
			s=s + " : " + str(i)
		return s
	def ScegliCarta(self,briscola=None,intavola=None):
		return self.carteinmano[0]
	
class GiocatoreRandom(Giocatore):
	'sceglie una carta a caso tra quelle che ha in mano'
	def ScegliCarta(self,briscola=None,intavola=None):
		import random
		n = len(self.carteinmano)
		c = self.carteinmano[random.randrange(n)]
		return c

class GiocatoreSprecone(Giocatore):
	"tira sempre la carta piu' alta che ha in mano"
	def ScegliCarta(self,briscola=None,intavola=None):
		c = self.carteinmano[0]
		for i in self.carteinmano:
			if i.Punti() > c.Punti():
				c = i
		return c

class GiocatoreTimido(Giocatore):
	"tira sempre la carta piu' bassa che ha in mano"
	def ScegliCarta(self,briscola=None,intavola=None):
		c = self.carteinmano[0]
		for i in self.carteinmano:
			if i.Punti() < c.Punti():
				c = i
		return c

	